import { createAsyncThunk } from "@reduxjs/toolkit";
import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";

export const provinceSubmitBarDifferenceService = createAsyncThunk(
  "PROVINCE_CREATE_BAR_DIFFERENCE_SERVICE",
  async (d, { dispatch }) => {
    try {
      dispatch(LOADING_START());
      const { data, status } = await axios.post("bar-difference-request/", d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceEditBarDifferenceService = createAsyncThunk(
  "PROVINCE_EDIT_BAR_DIFFERENCE_SERVICE",
  async (d, { dispatch }) => {
    try {
      dispatch(LOADING_START());
      const { data, status } = await axios.put("bar-difference-request/0/", d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceDeleteBarDifferenceService = createAsyncThunk(
  "PROVINCE_DELETE_BAR_DIFFERENCE_SERVICE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.delete(
        `bar-difference-request/0/?bar_key=${d}`
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceGetBarDifferenceInfoService = createAsyncThunk(
  "PROVINCE_GET_BAR_DIFFERENCE_INFO_SERVICE",
  async (d) => {
    const { data, status } = await axios.get("get_hatching_kill_ingo/", {
      params: d,
    });
    return { data, status };
  }
);
